 // Import libraries
import codeanticode.syphon.*;
import oscP5.*;
import netP5.*;
 // Create syphon class.  
class SFD{
  PGraphics canvas;
  SyphonServer server;
  PApplet that;
  SFD(PApplet tthat){
  that = tthat;
  // Create canvas   
  canvas = createGraphics(that.width, that.height, P3D);
  // Create syhpon server to send frames out.
  server = new SyphonServer(that, "Processing Syphon");
  }
  void update(){
    that.loadPixels();
    canvas.loadPixels();
    for(int i=0;i<that.pixels.length;i++){
      canvas.pixels[i] = that.pixels[i];
    }
    canvas.updatePixels();
    server.sendImage(canvas);
  }
}
 // Create OSC class.  
class Osc {
  OscP5 oscP5;
  NetAddress myBroadcastLocation;
  // OSC SETUP 
  public Osc() {
    oscP5 = new OscP5(this, 5001);
    factor = 1;
    factorX = 1;
    factorY = 1;
  }
  // RECEIVE ORDER OSC isadora/1 isadora/2 isadora/3 port:5001
  public void oscEvent(OscMessage theOscMessage)
  {
    if ( theOscMessage.addrPattern().equals("/isadora/0") )
    {
      factor = theOscMessage.get(0).floatValue()/100;
    } 
    if ( theOscMessage.addrPattern().equals("/isadora/1") )
    {
      factorX = theOscMessage.get(0).floatValue()/100;
    } 
     if ( theOscMessage.addrPattern().equals("/isadora/2") )
    {
      factorY = theOscMessage.get(0).floatValue()/100;
    } 
  }
}


//main------------------------------------------------
float factor;  //OSCvalue Color BG
float factorX; //OSCvalue rotate X
float factorY; //OSCvalue rotate Y
//Global---------------------------------------------- 
SFD send; //as a global SyphonServer
Osc osc;  //as a global OscReciever

// YOUR Scetch ---------------------------------------


void setup()
{
  size(640, 480, P3D);
  createGraphics(640, 480, P3D);
  //Add in setup();-----------------------------------
  send = new SFD(this); //in setup(); syphon
  osc = new Osc();      //in setup(); OSC

}



void draw()
{
  background(127, 127*factor, 127*factor);
  translate(width/2, height/2);
  rotateX(factorX);
  rotateY(factorY);  
  box(150);
  //Add in draw();RENDER AND SEND TO SYPHON----------
  send.update();  //SEND TO SYPHON
  
}



